﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace ornek1
{
    public partial class Form1 : Form
    {
        MySqlDataAdapter da_form1, da_form2;
        DataTable dt_form1, dt_form2;
        public Form1()
        {
            InitializeComponent();

            MySqlConnectionStringBuilder bag = new MySqlConnectionStringBuilder();
            bag.Server = "localhost";
            bag.UserID = "root";
            bag.Password = "123456";
            bag.Database = "y15hafta6";

            MySqlConnection conn = new MySqlConnection(bag.ToString());


            MySqlCommand cmd_form1_sel = new MySqlCommand("select idalimsatim,adi,miktar,islem,miktar*fiyat as tutar, dovizid,fiyat,alis,satis from alimsatim inner join dovizkuru on iddovizkuru=dovizid", conn);
            MySqlCommand cmd_form1_ins = new MySqlCommand("insert into alimsatim(dovizid,miktar,islem,fiyat) values(@dovizid,@miktar,@islem,@fiyat);", conn);
            cmd_form1_ins.Parameters.Add("@dovizid", MySqlDbType.Int32, 11, "dovizid");
            cmd_form1_ins.Parameters.Add("@miktar", MySqlDbType.Int32, 11, "miktar");
            cmd_form1_ins.Parameters.Add("@islem", MySqlDbType.Int32, 11, "islem");
            cmd_form1_ins.Parameters.Add("@fiyat", MySqlDbType.Double, 11, "fiyat");
           
            MySqlCommand cmd_form1_del = new MySqlCommand("delete from alimsatim where idalimsatim=@idalimsatim", conn);
            cmd_form1_del.Parameters.Add("@idalimsatim", MySqlDbType.Int32, 11, "idalimsatim");
            da_form1 = new MySqlDataAdapter();
            da_form1.SelectCommand = cmd_form1_sel;
            da_form1.InsertCommand = cmd_form1_ins;
            da_form1.DeleteCommand = cmd_form1_del;

            MySqlCommand cmd_form2_sel = 
                new MySqlCommand("select iddovizkuru,adi,alis,satis from dovizkuru;", conn);
            MySqlCommand cmd_form2_ins = 
                new MySqlCommand("insert into dovizkuru(adi,alis,satis) values(@adi,@alis,@satis);", conn);
            cmd_form2_ins.Parameters.Add("@adi", MySqlDbType.VarChar, 45, "adi");
            cmd_form2_ins.Parameters.Add("@alis", MySqlDbType.Double, 11, "alis");
            cmd_form2_ins.Parameters.Add("@satis", MySqlDbType.Double, 11, "satis");

            MySqlCommand cmd_form2_upd =
                new MySqlCommand("update dovizkuru set alis=@alis,satis=@satis where iddovizkuru=@iddovizkuru;", conn);
            cmd_form2_upd.Parameters.Add("@iddovizkuru", MySqlDbType.Int32, 11, "iddovizkuru");
            cmd_form2_upd.Parameters.Add("@alis", MySqlDbType.Double, 11, "alis");
            cmd_form2_upd.Parameters.Add("@satis", MySqlDbType.Double, 11, "satis");
           
            da_form2 = new MySqlDataAdapter();
            da_form2.SelectCommand = cmd_form2_sel;
            da_form2.InsertCommand = cmd_form2_ins;
            da_form2.UpdateCommand = cmd_form2_upd;

            verigetir();
        }

        private void verigetir()
        {
            radioButton1.Checked = true;

            dt_form1 = new DataTable();
            dt_form2 = new DataTable();

            try
            {
                da_form1.Fill(dt_form1);
                da_form2.Fill(dt_form2);

                ckur.Items.Clear();

                for (int satir = 0; satir < dt_form2.Rows.Count; satir++)
                    ckur.Items.Add(dt_form2.Rows[satir]["adi"]);

                ckur.Text = "Seçiniz";

                dataGridView1.DataSource = dt_form1;
                dataGridView1.Columns[0].Visible = false;
                dataGridView1.Columns[1].ReadOnly = true;
                dataGridView1.Columns[2].ReadOnly = true;
                dataGridView1.Columns[3].ReadOnly = true;
                dataGridView1.Columns[4].ReadOnly = true;
                dataGridView1.Columns[5].Visible = false;
                dataGridView1.Columns[6].Visible = false;
                dataGridView1.Columns[7].Visible = false; // alis 
                dataGridView1.Columns[8].Visible = false; // satis

                dataGridView1.AllowUserToAddRows = false;
                dataGridView1.AllowUserToDeleteRows = false;

                dataGridView1.Columns[1].HeaderText = "Döviz Adı";
                dataGridView1.Columns[2].HeaderText = "Miktar";
                dataGridView1.Columns[3].HeaderText = "İşlem";
                dataGridView1.Columns[4].HeaderText = "Tutar";

                dataGridView1.Columns[1].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
                dataGridView1.Columns[2].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
                dataGridView1.Columns[3].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
                dataGridView1.Columns[4].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;

                tutarhesapla();

            }
            catch { 
            }
        
        }


        private bool kontrolet(int dovizid,int miktar)
        { // satis sinirlandirmasi

            int alinan = 0;
            int satilan = 0;

            for (int satir = 0; satir < dt_form1.Rows.Count; satir++)
            {
                if ((int)dt_form1.Rows[satir]["dovizid"] == dovizid)
                {
                    if ((int)dt_form1.Rows[satir]["islem"] == 0)
                        alinan += (int)dt_form1.Rows[satir]["miktar"];
                    else
                        satilan += (int)dt_form1.Rows[satir]["miktar"];
                }
            }

            if (alinan >= (satilan + miktar)) // satilmak istenen miktar yeterli ise
                return false;
            return true;
        }

        private void tutarhesapla()
        { 
        double tutar=0;

        int dovizid = 0;

        for (int satir = 0; satir < dt_form2.Rows.Count; satir++)
        {
            dovizid = (int)dt_form2.Rows[satir]["iddovizkuru"];

            int alinan = 0;
            int satilan = 0;

            for (int satir1 = 0; satir1 < dt_form1.Rows.Count; satir1++)
            {
                if ((int)dt_form1.Rows[satir1]["dovizid"] == dovizid)
                {
                    if ((int)dt_form1.Rows[satir1]["islem"] == 0)
                    {
                        alinan += (int)dt_form1.Rows[satir1]["miktar"];
                        tutar -= (double)dt_form1.Rows[satir1]["tutar"];
                    }
                    else
                    {
                        satilan += (int)dt_form1.Rows[satir1]["miktar"];
                        tutar += (double)dt_form1.Rows[satir1]["tutar"];
                    }

                }
            }
            if (alinan > satilan)
            { // satilmayan doviz varsa guncel kuru kullanarak fiyatlandir
                tutar += (alinan - satilan) * (double)dt_form2.Rows[satir]["alis"];
            }
        
        }



            latutar.Text = "Tutar: " + Math.Round(tutar,2) + " TL";
        }

        private void bkurtanimla_Click(object sender, EventArgs e)
        {
            fkurtanimla frm = new fkurtanimla(da_form2);
            frm.ShowDialog();
            verigetir();
        }

        private void bekle_Click(object sender, EventArgs e)
        {
            int secilen = ckur.SelectedIndex;
            int miktar;
            bool k = Int32.TryParse(tmiktar.Text, out miktar);

            if(k && secilen>-1 && miktar>0)
            {
                int islem = 0;
                double fiyat =(double) dt_form2.Rows[secilen]["satis"]; // bizim aldigimiz deger satis fiyati uzerinden

                if (radioButton2.Checked)
                {
                    islem = 1;
                    fiyat = (double)dt_form2.Rows[secilen]["alis"];
                }

                int dovizid = (int)dt_form2.Rows[secilen]["iddovizkuru"];

                if(radioButton2.Checked && kontrolet(dovizid,miktar))
                {
                    // satim yapiliyorsa ve miktar mevcut doviz miktarini asiyor ise yeterli degilse islemi sonlandir
                    MessageBox.Show("Döviz miktarı satılacak miktardan fazla!");
                    return; // fonksiyondan cik
                }

                try
                {
                    DataRow dr = dt_form1.NewRow();
                    dr["dovizid"] = dovizid;
                    dr["miktar"] = miktar;
                    dr["islem"] = islem;
                    dr["fiyat"] = fiyat;

                    dt_form1.Rows.Add(dr);
                    da_form1.Update(dt_form1);
                    tmiktar.Clear();

                }
                catch { 
                    
                }


            }

            verigetir();


        }

    }
}
